function lambda = df_to_lambda_eig(df,e)

% Compute lambda from df by binary search -> brute force binary search!
% first consider only the non zero eigenvalues
% outputs NaN if df is greater than that number
% outputs Inf if df is just below that number
%
% Original code written by Francis Bach.

e = e(e>1e-12);
n = length(e);
if df>n+1e-12, lambda = NaN; return; end
if df>n-1e-12, lambda = 0; return; end


% binary search on log(lambda)
a = 0;
b = 0;

% first increase b and decrease a to
while sum(  e./ ( n * exp(b) + e ) ) > df, b = b + 1; end
while sum(  e./ ( n * exp(a) + e ) ) < df, a = a - 1; end
while (b-a)>1e-12
         c=(a+b)/2;
         if sum(  e./ ( n * exp(c) + e ) ) > df, a = c; else b=c; end
end

lambda = exp((a+b)/2);
end