function m = multiply(scal,mat)

% Multiplies a matrix by a scalar, while allowing Inf * 0 = 0.
%
% m = multiplier(scal,mat)
%
% Input :
% scal : real number
% mat = matrix
% 
% Output :
% m = scal*mat

m = mat ; 
if scal == Inf
    m(m==0) = 0;
    m(m~=0) = scal*(m(m~=0));
else
    m = scal * mat;
end 
end


